<?php
session_start();
include "../../inc/config.php";
$config_feeder = $db->fetch_single_row('config_user','id',1);
$id_sp = $config_feeder->id_sp;
$user_id = $config_feeder->id_user;
$json_response = array();
$jumlah = array();
if ($_POST['total_data']>0) {
		$url_rest = get_service_url('rest');
		$offset = $_POST['offset'];
		$jumlah['offset'] = $offset;
		$token = $_POST['token'];
		$jumlah['token'] = $_POST['token'];

		if ($offset==0) {
			$token = get_token();
		    $jumlah['token'] = $token;
		}

		$error_kelas = "";
		$sukses_count = 0;
		$error_count = 0;
		$error_count_in = 0;
		$error_msg = array();
		$update_data = array();
		$update_data_status = array();
	
		$update_data_er =array();
		$update_data_er_status =array();
		$error_mk = "";

		$data_id_sukses = array();
		$data_id_error= array();
	
		$all_errors = array();
		$all_error = array();
		$query_not_in = "";
		$id_mk = "";
		$error_mk = "";
		$msg = "";
		$query_matkul = '';
		$query_kelas = '';
		$query_jurusan = '';
		$all_id = array();
		$data_rencana = array();
		$data_kls = array();
		$filter_mk_where = array();

		$array_id_mk = array();
		$array_id_mk_cross = array();
		$data_rencana_evaluasi = array();
		$error_data = "";
		$error_update_data = array();
		$data_id_error = array();
		$array_exist_evaluasi = array();
		$kode_mk = array();

		//merdeka
		$data_rencana = array();


		if ($_POST['matkul']!='all') {
			$query_matkul = "and trim(kode_mk)='".trim($_POST['matkul'])."'";
		}

		if ($_POST['jurusan']!='all') {
			$query_jurusan = "and trim(jurusan.kode_jurusan)='".trim($_POST['jurusan'])."'";
		} else {
			if ($_SESSION['level']!=1) {
				$query_jurusan = "and trim(jurusan.kode_jurusan)='".$_SESSION['jurusan']."'";
			} else {
				$query_jurusan = "";
			}
		}

 		$query_not_in = "and unik_id not in(".$_POST['random_number'].")";

 		$get_kode_mk = $db->fetch_custom_single("select mat_rencana_evaluasi.id as id_evaluasi,mat_rencana_evaluasi.*,nm_jns_eval,jurusan.kode_jurusan,id_sms from mat_rencana_evaluasi inner join jurusan on mat_rencana_evaluasi.kode_jurusan=jurusan.kode_jurusan 
			left join jenis_evaluasi on id_basis_evaluasi=jenis_evaluasi.id_jns_eval
			where mat_rencana_evaluasi.id is not null $query_jurusan and status_error!=1 $query_matkul $query_not_in group by kode_mk,jurusan.kode_jurusan limit 1");

		$data = $db->fetch_custom("select mat_rencana_evaluasi.id as id_evaluasi,mat_rencana_evaluasi.*,nm_jns_eval,jurusan.kode_jurusan,id_sms from mat_rencana_evaluasi inner join jurusan on mat_rencana_evaluasi.kode_jurusan=jurusan.kode_jurusan 
			left join jenis_evaluasi on id_basis_evaluasi=jenis_evaluasi.id_jns_eval
			where mat_rencana_evaluasi.id is not null $query_jurusan and status_error!=1 $query_matkul $query_not_in");

		foreach ($data as $dt_id) {
			$filter_mk_where[$dt_id->id_sms.convert_ascii($dt_id->kode_mk)] = "('".$dt_id->id_sms."','".convert_ascii($dt_id->kode_mk)."')";
			$data_rencana_evaluasi[] = $dt_id;
			$array_structure[] = array(
				'urutan' => $dt_id->nomor_urut,
				'id_jns_eval' => $dt_id->id_basis_evaluasi,
				'nama' => $dt_id->komponen_evaluasi
			);
			$ids_array[] = $dt_id->id;
		}

		$data_check_evaluasi23 = array();


		if (!empty($filter_mk_where)) {
			$implode_id_mk = implode(",", $filter_mk_where);
			$filter_mk = "(id_prodi,trim(kode_mata_kuliah)) IN ($implode_id_mk)";
			$data_req_mat = [
				'act' => 'GetListMataKuliah',
			    'token' => $token,
			    'filter' => $filter_mk,
			    'order' => "",
			    'limit' => "",
			    'offset' => ""

			];
			$check_matkul_exist = json_decode($db->run($data_req_mat,$url_rest));
			$filter_check_evaluasi = array();
			if (!empty($check_matkul_exist->data)) {
				foreach ($check_matkul_exist->data as $dts) {
					$filter_check_evaluasi[] = "'".$dts->id_matkul."'";
					$array_id_mk[$dts->id_prodi.convert_ascii($dts->kode_mata_kuliah)] = array(
						'id_mk' => $dts->id_matkul,
						'kode_mata_kuliah' => $dts->kode_mata_kuliah,
						'id_prodi' => $dts->id_prodi,
						'sks_mk' => $dts->sks_mata_kuliah,
						'sks_tm' => $dts->sks_tatap_muka,
					    'sks_prak' => $dts->sks_praktek,
				   		'sks_prak_lap' => $dts->sks_praktek_lapangan,
						'sks_sim' => $dts->sks_simulasi
					); 
				}				
			}

			//check if evaluasi exist
			if (!empty($filter_check_evaluasi)) {
				
				$implode_id = implode(",", $filter_check_evaluasi);
				$data_req_mat = [
					'act' => 'GetListRencanaEvaluasi',
				    'token' => $token,
				    'filter' => "id_matkul in($implode_id)",
				    'order' => "",
				    'limit' => "",
				    'offset' => ""

				];
				$get_evaluasi = service_request($data_req_mat);
				$data_check_evaluasi = array();
				$re_mk_array = array();
				if (!empty($get_evaluasi->data)) {
					foreach ($get_evaluasi->data as $dts) {
						$re_mk_array[$dts->id_prodi.convert_ascii($dts->kode_mata_kuliah).$dts->id_jenis_evaluasi.$dts->nama_evaluasi.$dts->nomor_urut] = $dts->id_rencana_evaluasi;
						$data_check_evaluasi[$dts->id_prodi.convert_ascii($dts->kode_mata_kuliah).$dts->id_jenis_evaluasi.$dts->nama_evaluasi] = $dts;
						$data_check_evaluasi23[$dts->id_prodi.convert_ascii($dts->kode_mata_kuliah).$dts->id_jenis_evaluasi] = $dts;
					}
					
				}
			}
		}

$array_kom = array(
'TGS','QIZ','UTS','UAS'
);
//check validasi
function validasiData($val) {
	global $db;
	//check if jumlah is 6 record
	$jml_record = $db->fetch_custom_single("select count(id) as jml_record,sum(bobot_evaluasi) as jml_bobot from mat_rencana_evaluasi where kode_jurusan='$val->kode_jurusan' and kode_mk='$val->kode_mk'");
	if ($jml_record->jml_record!=6) {
		$res = array(
			'status' => false,
			'error_desc' => 'Pastikan jumlah data untuk evaluasi mata kuliah ini berjumlah 6 data'
		);
	} elseif ($jml_record->jml_bobot < 100) {
		$res = array(
			'status' => false,
			'error_desc' => 'Total bobot evaluasi untuk matakuliah ini tidak boleh kurang dari 100'
		);
	} elseif ($jml_record->jml_bobot > 100) {
		$res = array(
			'status' => false,
			'error_desc' => 'Total bobot evaluasi untuk matakuliah ini tidak boleh lebih dari 100'
		);
	} else {
		$res = array(
			'status' => true,
			'error_desc' => 'Total bobot evaluasi untuk matakuliah ini tidak boleh lebih dari 100'
		);
	}
	return $res;
}
		$is_hapus = 0;
		if (!empty($data_rencana_evaluasi)) {
			foreach ($data_rencana_evaluasi as $dt) {
				if ($dt->id_basis_evaluasi==2) {
					$nomor_urut = 1;
				} elseif ($dt->id_basis_evaluasi==3) {
					$nomor_urut = 2;
				} elseif ($dt->id_basis_evaluasi==4 && $dt->komponen_evaluasi=='TGS') {
					$nomor_urut = 3;
				} elseif ($dt->id_basis_evaluasi==4 && $dt->komponen_evaluasi=='QIZ') {
					$nomor_urut = 4;
				} elseif ($dt->id_basis_evaluasi==4 && $dt->komponen_evaluasi=='UTS') {
					$nomor_urut = 5;
				} elseif ($dt->id_basis_evaluasi==4 && $dt->komponen_evaluasi=='UAS') {
					$nomor_urut = 6;
				}
				if (!in_array($dt->id_sms.convert_ascii($dt->kode_mk), array_keys($array_id_mk))) {
					$error_update_data[] = array(
						'keterangan' => "Kode MK $dt->kode_mk tidak ditemukan di Feeder",
						'status_error' => 2
					);
					$data_id_error[] = $dt->id;
				} elseif (in_array($dt->id_basis_evaluasi,array(4)) && !in_array($dt->komponen_evaluasi,$array_kom)) {
					$error_update_data[] = array(
						'keterangan' => "Pastikan data sesuai format template",
						'status_error' => 2
					);
					$data_id_error[] = $dt->id;
				} elseif (!in_array($dt->id_basis_evaluasi,array(2,3,4))) {
					$error_update_data[] = array(
						'keterangan' => "Pastikan data sesuai format template",
						'status_error' => 2
					);
					$data_id_error[] = $dt->id;
				} elseif (validasiData($dt)['status']==false) {
					$error_update_data[] = array(
						'keterangan' => validasiData($dt)['error_desc'],
						'status_error' => 2
					);
					$data_id_error[] = $dt->id;
				} else {
						if ($_POST['method']=='up') {
							if (in_array($dt->id_basis_evaluasi,array(2,3)) && !in_array($dt->id_sms.convert_ascii($dt->kode_mk).$dt->id_basis_evaluasi,array_keys($data_check_evaluasi23))) {
								$error_update_data[] = array(
								'keterangan' => "Rencana Evaluasi ini sudah ada di feeder, pilih metode update jika ingin update",
								'status_error' => 2
							);
								$data_id_error[] = $dt->id;
							} elseif (in_array($dt->id_basis_evaluasi,array(4)) && !in_array($dt->id_sms.convert_ascii($dt->kode_mk).$dt->id_basis_evaluasi.$dt->komponen_evaluasi,array_keys($data_check_evaluasi))) {
								$error_update_data[] = array(
								'keterangan' => "Rencana Evaluasi ini sudah ada di feeder, pilih metode update jika ingin update",
								'status_error' => 2
							);
								$data_id_error[] = $dt->id;
							} else {
									$record_update = array(
										'id_matkul' => $array_id_mk[$dt->id_sms.convert_ascii($dt->kode_mk)]['id_mk'],
										'id_jenis_evaluasi' => $dt->id_basis_evaluasi,
										'nama_evaluasi' => $dt->komponen_evaluasi,
										'deskripsi_indonesia' => $dt->deskripsi_indonesia,
										'deskripsi_inggris' => $dt->deskripsi_inggris,
										'nomor_urut' => $nomor_urut,
										'bobot_evaluasi' => (float)$dt->bobot_evaluasi
									);
									if ($dt->id_basis_evaluasi==2 or $dt->id_basis_evaluasi==3) {
										$temp_data_update['nama_evaluasi'] = NULL;
										$key_update['id_rencana_evaluasi'] = $data_check_evaluasi23[$dt->id_sms.convert_ascii($dt->kode_mk).$dt->id_basis_evaluasi]->id_rencana_evaluasi;
									} else {
										$key_update['id_rencana_evaluasi'] = $data_check_evaluasi[$dt->id_sms.convert_ascii($dt->kode_mk).$dt->id_basis_evaluasi.$dt->komponen_evaluasi]->id_rencana_evaluasi;
									}


									
									  $data_dic = [
									      'act' => 'UpdateRencanaEvaluasi',
									      'key' => $key_update,
									        'token' => $token,
									        'record' => $record_update,
									    ];
									$update_evaluasi = service_request($data_dic);
									$value_data = addslashes($update_evaluasi->error_desc);
									if ($value_data!='') {
										$error_update_data[] = array(
											'keterangan' => $value_data,
											'status_error' => 2
										);
										$data_id_error[] = $dt->id_evaluasi;
									} else {
										$update_data[] = array(
											'keterangan' => '',
											'status_error' => 1
										);
										$data_id_sukses[] = $dt->id_evaluasi;
									}

						}

						} elseif ($_POST['method']=='in') {
							if (in_array($dt->id_basis_evaluasi,array(2,3)) && in_array($dt->id_sms.convert_ascii($dt->kode_mk).$dt->id_basis_evaluasi,array_keys($data_check_evaluasi23))) {
								$error_update_data[] = array(
								'keterangan' => "Rencana Evaluasi ini sudah ada di feeder, pilih metode update jika ingin update",
								'status_error' => 2
							);
								$data_id_error[] = $dt->id;
							} elseif (in_array($dt->id_basis_evaluasi,array(4)) && in_array($dt->id_sms.convert_ascii($dt->kode_mk).$dt->id_basis_evaluasi.$dt->komponen_evaluasi,array_keys($data_check_evaluasi))) {
								$error_update_data[] = array(
								'keterangan' => "Rencana Evaluasi ini sudah ada di feeder, pilih metode update jika ingin update",
								'status_error' => 2
							);
								$data_id_error[] = $dt->id;
							} else {
								$temp_data_insert = array(
										'id_jenis_evaluasi' => $dt->id_basis_evaluasi,
										'id_matkul' => $array_id_mk[$dt->id_sms.convert_ascii($dt->kode_mk)]['id_mk'],
										'nama_evaluasi' => $dt->komponen_evaluasi,
										'deskripsi_indonesia' => $dt->deskripsi_indonesia,
										'deskripsi_inggris' => $dt->deskripsi_inggris,
										'nomor_urut' => $nomor_urut,
										'bobot_evaluasi' => (float)$dt->bobot_evaluasi
									);
								//dump($temp_data_insert);
								if ($dt->id_basis_evaluasi==2 or $dt->id_basis_evaluasi==3) {
										$temp_data_insert['nama_evaluasi'] = NULL;
									}
								  	$data_dic = [
								      'act' => 'InsertRencanaEvaluasi',
								        'token' => $token,
								        'record' => $temp_data_insert,
								    ];
								    $temp_recs = service_request($data_dic);
							/*	    dump($data_dic);
								    dump($temp_recs);*/

									$value_data = addslashes($temp_recs->error_desc);
									if ($value_data!='') {
										$error_update_data[] = array(
											'keterangan' => $value_data,
											'status_error' => 2
										);
										$data_id_error[] = $dt->id_evaluasi;
									} else {
										$update_data[] = array(
											'keterangan' => '',
											'status_error' => 1
										);
										$data_id_sukses[] = $dt->id_evaluasi;
									}
							}

						}

				}
					$all_id[] = $dt->id;
			}
		}

		//update error
		if (!empty($error_update_data)) {
			updateMulti('mat_rencana_evaluasi',$error_update_data,'id',$data_id_error);
		}
		//update sukses
		if (!empty($update_data)) {
			updateMulti('mat_rencana_evaluasi',$update_data,'id',$data_id_sukses);
		}


		$update_data = array();
		$data_id_sukses = array();

		$implode_id = implode(",", $all_id);

	
		

		//$db->fetch_custom("update mat_rencana_evaluasi set unik_id=".$_POST['random_number']." where concat(kode_mk,kode_jurusan) IN('".implode("','",$kode_mk)."')");

		$db->fetch_custom("update mat_rencana_evaluasi set unik_id=".$_POST['random_number']." where id in (".$implode_id.")");

		//echo $db->getErrorMessage();

	if (isset($_POST['id_data'])) {

		$jml_error_sukses = $db->fetch_custom_single("SELECT COUNT(IF(status_error='1',1,NULL)) AS jml_sukses,COUNT(IF(status_error='2',1,NULL)) AS jml_error FROM mat_rencana_evaluasi where unik_id=".$_POST['random_number']);

		$jumlah_sukses = $jml_error_sukses->jml_sukses;
		$jumlah_error = $jml_error_sukses->jml_error;

		$db->fetch_custom("update mat_rencana_evaluasi set unik_id=0 where unik_id=".$_POST['random_number']);

	
		$msg =  "<div class=\"alert alert-warning \" role=\"alert\">
		<font color=\"#3c763d\">".$jumlah_sukses." data Rencana Evaluasi berhasil Di Import Ke Feeder DIKTI</font><br />
		<font color=\"#ce4844\" >".$jumlah_error." data tidak bisa Di Import </font>";
		
		if (!$jumlah_error==0) {
			$msg .= "<a data-toggle=\"collapse\" href=\"#collapseExample\" aria-expanded=\"false\" aria-controls=\"collapseExample\">Detail error</a>";
			//pesan error 
			$all_errors = array('Silakan lihat detail error di list data');
			
		}
		//echo "<br />Total: ".$i." baris data";
		$msg .= "<div class=\"collapse\" id=\"collapseExample\">";
				$i=1;
				foreach ($all_errors as $pesan) {
						$msg .= "<div class=\"bs-callout bs-callout-danger\">".$i.". ".$pesan."</div><br />";
					$i++;
					}
		$msg .= "</div>
		</div>";


		$jumlah['last_notif'] = $msg;
	}


} else {
	$msg =  "Tidak ada data yang bisa diproses<p>";
		$jumlah['last_notif'] = $msg;
}

array_push($json_response, $jumlah);
echo json_encode($json_response);
//echo convert(memory_get_usage(true)); // 123 kb